package controllers_pages

import (
	"main/mvc/models"
	"main/mvc/models/models_pages"
	"net/http"
)

// Обработчик главной страницы
func PostsPageHandler(app *models.App) http.HandlerFunc {
	return http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		var err error

		// Страничка рендерится только если ее нет в кэше
		pageData, ok := app.PagesCache.Get(models_pages.PostsPageTmplName)
		if !ok {
			pageData, err = app.Posts.RenderPostsPage(app.Templates, app.Version)
			if err != nil {
				http.Error(w, err.Error(), http.StatusInternalServerError)
				return
			}
			app.PagesCache.Set(models_pages.PostsPageTmplName, pageData)
		}

		sendPostsPage(w, pageData)
	})
}

// Отправляет страницу
func sendPostsPage(w http.ResponseWriter, data []byte) {
	w.Header().Set("Content-Type", "text/html; charset=utf-8")
	w.WriteHeader(http.StatusOK)
	w.Write(data)
}
